#pragma semicolon 1

#include <sourcemod>
#include <sdktools_engine>
#include <knife_arena>

public Plugin:myinfo = 
{
	name	= "Knife Arena [Control]",
	author	= "wS",
	version = "1.1"
};

new g_LastDamage[MAXPLAYERS + 1], g_LastLeave[MAXPLAYERS + 1], g_ArenaTimes[MAXPLAYERS + 1];
new damage_timer, leave_timer, arena_limit, Float:enemy_near, Float:enemy_timer;
new Handle:g_hEnemyTimer = INVALID_HANDLE;
new bool:g_bC4Planted, bool:g_bC4PlantedControl;

public OnPluginStart()
{
	LoadTranslations("knife_arena_control.phrases");
	
	//
	decl Handle:hCvar;
	
	hCvar			= CreateConVar("ka_control_damage_timer",	"15",	"If take damage from enemy then arena will be aviable after 'x' sec");
	damage_timer	= GetConVarInt(hCvar);
	HookConVarChange(hCvar, cvar_damage_timer);
	
	hCvar			= CreateConVar("ka_control_leave_timer",	"60",	"If player leave arena (self) then arena will be aviable after 'x' sec");
	leave_timer		= GetConVarInt(hCvar);
	HookConVarChange(hCvar, cvar_leave_timer);
	
	hCvar			= CreateConVar("ka_control_arena_limit",	"1",	"How many times a player can enter the arena in a round (0 = unlimit)");
	arena_limit		= GetConVarInt(hCvar);
	HookConVarChange(hCvar, cvar_arena_limit);
	
	hCvar			= CreateConVar("ka_control_enemy_near",		"350",	"Restrict queue if enemy near (units) (player height = 73 units)");
	enemy_near		= GetConVarFloat(hCvar);
	HookConVarChange(hCvar, cvar_enemy_near);
	
	hCvar			= CreateConVar("ka_control_enemy_timer",	"10",	"Force the player to leave the arena after 'x' sec if the opponent does not enter (0 = off)");
	enemy_timer		= GetConVarFloat(hCvar);
	HookConVarChange(hCvar, cvar_enemy_timer);
	
	hCvar			= CreateConVar("ka_control_c4planted",		"1",	"1 = Prohibit the entrance to the arena after planting the bomb (0 = off)");
	g_bC4PlantedControl		= GetConVarBool(hCvar);
	HookConVarChange(hCvar, cvar_c4planted);
	
	AutoExecConfig(true, "control", "knife_arena/modules");
	//
	
	KA_HookEvent(KA_Event:KA_OnPushToQueue,						Function:OnPushToQueue);
	KA_HookEvent(KA_Event:KA_OnArenaClientRemoved,				Function:OnArenaClientRemoved);
	KA_HookEvent(KA_Event:KA_OnPushFromQueueToArenaPost,		Function:OnPushFromQueueToArenaPost);
	KA_HookEvent(KA_Event:KA_OnPushFromQueueToArena,			Function:OnPushFromQueueToArena);
	
	HookEvent("round_start",	round_start,	EventHookMode_PostNoCopy);
	HookEvent("player_hurt",	player_hurt,	EventHookMode_Post);
	HookEvent("bomb_planted",	bomb_planted,	EventHookMode_PostNoCopy);
}

public cvar_damage_timer(Handle:h, const String:o[], const String:n[]) damage_timer	= StringToInt(n);
public cvar_leave_timer (Handle:h, const String:o[], const String:n[]) leave_timer	= StringToInt(n);
public cvar_arena_limit (Handle:h, const String:o[], const String:n[]) arena_limit	= StringToInt(n);
public cvar_enemy_near  (Handle:h, const String:o[], const String:n[]) enemy_near	= StringToFloat(n);
public cvar_enemy_timer (Handle:h, const String:o[], const String:n[]) enemy_timer	= StringToFloat(n);
public cvar_c4planted 	(Handle:h, const String:o[], const String:n[]) g_bC4PlantedControl = StringToInt(n) == 1;

public OnArenaClientRemoved(client, KA_Reason:reason)
{
	g_LastDamage[client] = 0;
	if (reason == KA_Self) g_LastLeave[client] = GetTime();
	RestartEnemyTimer();
}

public round_start(Handle:event, const String:name[], bool:silent)
{
	for (new i = 1; i <= MaxClients; i++) clear(i);
	RestartEnemyTimer(true);
	g_bC4Planted = false;
}

public Action:OnPushFromQueueToArena(client)
{
	if (BombPlanted(client)) return Plugin_Stop;
	return Plugin_Continue;
}

public OnPushFromQueueToArenaPost(client)
{
	g_ArenaTimes[client]++;
	RestartEnemyTimer();
}

public OnClientDisconnect_Post(client) clear(client);
public OnMapStart() RestartEnemyTimer(true);

public player_hurt(Handle:event, const String:name[], bool:silent)
{
	if (damage_timer < 1) return;
	decl x;
	if ((x = GetEventInt(event, "attacker")) > 0 && (x = GetClientOfUserId(x)) > 0 && GetClientTeam(x) != GetClientTeam((x = GetClientOfUserId(GetEventInt(event, "userid")))))
	{
		g_LastDamage[x] = GetTime();
	}
}

public Action:OnPushToQueue(client) // конфликта с 1vs1 нет, т.к. после KA_PushToQueue forward OnPushToQueue не вызывается
{
	if (arena_limit > 0 && g_ArenaTimes[client] >= arena_limit)
	{
		PrintToChat(client, "%t", "arena_limit");
		warning(client);
		return Plugin_Stop;
	}
	
	new x = GetTime();
	
	if (damage_timer > 0 && (x - g_LastDamage[client]) < damage_timer)
	{
		PrintToChat(client, "%t", "damage_timer", (damage_timer - (x - g_LastDamage[client])));
		warning(client);
		return Plugin_Stop;
	}
	
	if (leave_timer  > 0 && (x - g_LastLeave [client]) < leave_timer)
	{
		PrintToChat(client, "%t", "leave_timer",  (leave_timer  - (x - g_LastLeave [client])));
		warning(client);
		return Plugin_Stop;
	}
	
	if (enemy_near > 1.0)
	{
		x = GetClientTeam(client);
		decl Float:v1[3], Float:v2[3];
		GetClientEyePosition(client, v1);
		for (new i = 1; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && IsPlayerAlive(i) && GetClientTeam(i) != x && !KA_ClientOnArena(i))
			{
				GetClientEyePosition(i, v2);
				if (GetVectorDistance(v1, v2) <= enemy_near)
				{
					PrintToChat(client, "%t", "enemy_near");
					warning(client);
					return Plugin_Stop;
				}
			}
		}
	}
	
	if (BombPlanted(client))
		return Plugin_Stop;
	
	return Plugin_Continue;
}

warning(client)
	ClientCommand(client, "playgamesound resource/warning.wav");

clear(client)
{
	g_LastDamage[client] = 0;
	g_LastLeave [client] = 0;
	g_ArenaTimes[client] = 0;
}

//

RestartEnemyTimer(bool:StopTimerOnly = false) // если соперника долго нет, кикаем игрока с арены
{
	if (g_hEnemyTimer != INVALID_HANDLE)
	{
		KillTimer(g_hEnemyTimer);
		g_hEnemyTimer = INVALID_HANDLE;
	}
	
	if (StopTimerOnly || enemy_timer < 1.0)
		return;
	
	decl t, ct;
	KA_GetArenaClients(t, ct);
	if (t > 0 && ct > 0 || t < 1 && ct < 1) // если оба на арене или она пустая, стоп
		return;
	
	g_hEnemyTimer = CreateTimer(enemy_timer, RestartEnemyTimer_CallBack);
}

public Action:RestartEnemyTimer_CallBack(Handle:timer)
{
	g_hEnemyTimer = INVALID_HANDLE;
	decl t, ct;
	KA_GetArenaClients(t, ct);
	if (t > 0 && ct < 1 || ct > 0 && t < 1)
	{
		ClearArenaQueue();
		new client = t > 0 ? t : ct;
		//g_ArenaTimes[client]--;
		KA_RemoveFromArena(client);
		PrintToChat(client, "%t", "enemy_timer");
	}
	return Plugin_Stop;
}

//

public bomb_planted(Handle:event, const String:name[], bool:silent)
{
	g_bC4Planted = true;
	ClearArenaQueue();
}

bool:BombPlanted(client)
{
	if (g_bC4PlantedControl && g_bC4Planted)
	{
		PrintToChat(client, "%t", "c4planted");
		return true;
	}
	return false;
}

ClearArenaQueue() // очищаем всю очередь
{
	for (new i = 1; i <= MaxClients; i++)
		KA_RemoveFromQueue(i);
}